import{S as Ot,i as Bt,s as Mt,e as a,k as u,w as $e,t as l,M as Rt,c as o,d as t,m as p,a as n,x as ze,h as c,b as h,G as i,g as s,y as Te,L as Wt,q as Se,o as ke,B as qe,v as Dt}from"../chunks/vendor-hf-doc-builder.js";import{I as Ie}from"../chunks/IconCopyLink-hf-doc-builder.js";function jt(ht){let f,oe,d,w,B,z,Ce,M,Ge,ne,I,Ne,re,g,y,R,T,Ue,W,xe,se,C,Le,le,_,D,G,j,He,Oe,Be,Z,N,J,Me,Re,ce,U,We,he,m,b,F,S,De,K,je,ue,x,Ze,pe,E,Q,L,V,Je,Fe,Ke,X,P,Y,Qe,Ve,k,Xe,Ye,fe,v,A,ee,q,et,te,tt,de,H,it,ge,$,at,ie,ot,nt,me,O,rt,ve;return z=new Ie({}),T=new Ie({}),S=new Ie({}),q=new Ie({}),{c(){f=a("meta"),oe=u(),d=a("h1"),w=a("a"),B=a("span"),$e(z.$$.fragment),Ce=u(),M=a("span"),Ge=l("Autoscaling"),ne=u(),I=a("p"),Ne=l("Autoscaling allows you to dynamically adjust the number of endpoint replicas running your models based on traffic and accelerator utilization. By leveraging autoscaling, you can seamlessly handle varying workloads while optimizing costs and ensuring high availability."),re=u(),g=a("h2"),y=a("a"),R=a("span"),$e(T.$$.fragment),Ue=u(),W=a("span"),xe=l("Scaling Criteria"),se=u(),C=a("p"),Le=l("The autoscaling process is triggered based on the accelerator\u2019s utilization metrics. The criteria for scaling differ depending on the type of accelerator being used:"),le=u(),_=a("ul"),D=a("li"),G=a("p"),j=a("strong"),He=l("CPU Accelerators"),Oe=l(": A new replica is added when the average CPU utilization of all replicas reaches 80%."),Be=u(),Z=a("li"),N=a("p"),J=a("strong"),Me=l("GPU Accelerators"),Re=l(": A new replica is added when the average GPU utilization of all replicas over a 2-minute window reaches 80%."),ce=u(),U=a("p"),We=l("It\u2019s important to note that the scaling up process takes place every 3 minutes, while the scaling down process takes 5 minutes. This frequency ensures a balance between responsiveness and stability of the autoscaling system."),he=u(),m=a("h2"),b=a("a"),F=a("span"),$e(S.$$.fragment),De=u(),K=a("span"),je=l("Considerations for Effective Autoscaling"),ue=u(),x=a("p"),Ze=l("While autoscaling offers convenient resource management, certain considerations should be kept in mind to ensure its effectiveness:"),pe=u(),E=a("ul"),Q=a("li"),L=a("p"),V=a("strong"),Je=l("Model Initialization Time"),Fe=l(": During the initialization of a new replica, the model is downloaded and loaded into memory. If your replicas have a long initialization time, autoscaling may not be as effective. This is because the average GPU utilization might fall below the threshold during that time, triggering the automatic scaling down of your endpoint."),Ke=u(),X=a("li"),P=a("p"),Y=a("strong"),Qe=l("Enterprise Plan Control"),Ve=l(": If you have an "),k=a("a"),Xe=l("enterprise plan"),Ye=l(", you have full control over the autoscaling definitions. This allows you to customize the scaling thresholds, behavior and criteria based on your specific requirements."),fe=u(),v=a("h2"),A=a("a"),ee=a("span"),$e(q.$$.fragment),et=u(),te=a("span"),tt=l("Scaling to 0"),de=u(),H=a("p"),it=l("Inference Endpoints also supports autoscaling to 0, which means reducing the number of replicas to 0 when there is no incoming traffic. This feature is based on request patterns rather than accelerator utilization. When an endpoint remains idle without receiving any requests for over 15 minutes, the system automatically scales down the endpoint to 0 replicas. To enable the feature, go to the Settings page and you\u2019ll find a section called \u201CAutomatic Scale-to-Zero\u201D."),ge=u(),$=a("p"),at=l("Scaling to 0 replicas helps optimize cost savings by minimizing resource usage during periods of inactivity. However, it\u2019s important to be aware that scaling to 0 implies a cold start period when the endpoint receives a new request. Additionally, the HTTP server will respond with a status code "),ie=a("code"),ot=l("502 Bad Gateway"),nt=l(" while the new replica is initializing. Please note that there is currently no queueing system in place for incoming requests. Therefore, we recommend developing your own request queue client-side with proper error handling to optimize throughput and latency."),me=u(),O=a("p"),rt=l("The duration of the cold start period varies depending on your model\u2019s size. It is recommended to consider the potential latency impact when enabling scaling to 0 and managing user expectations."),this.h()},l(e){const r=Rt('[data-svelte="svelte-1phssyn"]',document.head);f=o(r,"META",{name:!0,content:!0}),r.forEach(t),oe=p(e),d=o(e,"H1",{class:!0});var we=n(d);w=o(we,"A",{id:!0,class:!0,href:!0});var ut=n(w);B=o(ut,"SPAN",{});var pt=n(B);ze(z.$$.fragment,pt),pt.forEach(t),ut.forEach(t),Ce=p(we),M=o(we,"SPAN",{});var ft=n(M);Ge=c(ft,"Autoscaling"),ft.forEach(t),we.forEach(t),ne=p(e),I=o(e,"P",{});var dt=n(I);Ne=c(dt,"Autoscaling allows you to dynamically adjust the number of endpoint replicas running your models based on traffic and accelerator utilization. By leveraging autoscaling, you can seamlessly handle varying workloads while optimizing costs and ensuring high availability."),dt.forEach(t),re=p(e),g=o(e,"H2",{class:!0});var ye=n(g);y=o(ye,"A",{id:!0,class:!0,href:!0});var gt=n(y);R=o(gt,"SPAN",{});var mt=n(R);ze(T.$$.fragment,mt),mt.forEach(t),gt.forEach(t),Ue=p(ye),W=o(ye,"SPAN",{});var vt=n(W);xe=c(vt,"Scaling Criteria"),vt.forEach(t),ye.forEach(t),se=p(e),C=o(e,"P",{});var wt=n(C);Le=c(wt,"The autoscaling process is triggered based on the accelerator\u2019s utilization metrics. The criteria for scaling differ depending on the type of accelerator being used:"),wt.forEach(t),le=p(e),_=o(e,"UL",{});var _e=n(_);D=o(_e,"LI",{});var yt=n(D);G=o(yt,"P",{});var st=n(G);j=o(st,"STRONG",{});var _t=n(j);He=c(_t,"CPU Accelerators"),_t.forEach(t),Oe=c(st,": A new replica is added when the average CPU utilization of all replicas reaches 80%."),st.forEach(t),yt.forEach(t),Be=p(_e),Z=o(_e,"LI",{});var bt=n(Z);N=o(bt,"P",{});var lt=n(N);J=o(lt,"STRONG",{});var Et=n(J);Me=c(Et,"GPU Accelerators"),Et.forEach(t),Re=c(lt,": A new replica is added when the average GPU utilization of all replicas over a 2-minute window reaches 80%."),lt.forEach(t),bt.forEach(t),_e.forEach(t),ce=p(e),U=o(e,"P",{});var Pt=n(U);We=c(Pt,"It\u2019s important to note that the scaling up process takes place every 3 minutes, while the scaling down process takes 5 minutes. This frequency ensures a balance between responsiveness and stability of the autoscaling system."),Pt.forEach(t),he=p(e),m=o(e,"H2",{class:!0});var be=n(m);b=o(be,"A",{id:!0,class:!0,href:!0});var At=n(b);F=o(At,"SPAN",{});var $t=n(F);ze(S.$$.fragment,$t),$t.forEach(t),At.forEach(t),De=p(be),K=o(be,"SPAN",{});var zt=n(K);je=c(zt,"Considerations for Effective Autoscaling"),zt.forEach(t),be.forEach(t),ue=p(e),x=o(e,"P",{});var Tt=n(x);Ze=c(Tt,"While autoscaling offers convenient resource management, certain considerations should be kept in mind to ensure its effectiveness:"),Tt.forEach(t),pe=p(e),E=o(e,"UL",{});var Ee=n(E);Q=o(Ee,"LI",{});var St=n(Q);L=o(St,"P",{});var ct=n(L);V=o(ct,"STRONG",{});var kt=n(V);Je=c(kt,"Model Initialization Time"),kt.forEach(t),Fe=c(ct,": During the initialization of a new replica, the model is downloaded and loaded into memory. If your replicas have a long initialization time, autoscaling may not be as effective. This is because the average GPU utilization might fall below the threshold during that time, triggering the automatic scaling down of your endpoint."),ct.forEach(t),St.forEach(t),Ke=p(Ee),X=o(Ee,"LI",{});var qt=n(X);P=o(qt,"P",{});var ae=n(P);Y=o(ae,"STRONG",{});var It=n(Y);Qe=c(It,"Enterprise Plan Control"),It.forEach(t),Ve=c(ae,": If you have an "),k=o(ae,"A",{href:!0,rel:!0});var Ct=n(k);Xe=c(Ct,"enterprise plan"),Ct.forEach(t),Ye=c(ae,", you have full control over the autoscaling definitions. This allows you to customize the scaling thresholds, behavior and criteria based on your specific requirements."),ae.forEach(t),qt.forEach(t),Ee.forEach(t),fe=p(e),v=o(e,"H2",{class:!0});var Pe=n(v);A=o(Pe,"A",{id:!0,class:!0,href:!0});var Gt=n(A);ee=o(Gt,"SPAN",{});var Nt=n(ee);ze(q.$$.fragment,Nt),Nt.forEach(t),Gt.forEach(t),et=p(Pe),te=o(Pe,"SPAN",{});var Ut=n(te);tt=c(Ut,"Scaling to 0"),Ut.forEach(t),Pe.forEach(t),de=p(e),H=o(e,"P",{});var xt=n(H);it=c(xt,"Inference Endpoints also supports autoscaling to 0, which means reducing the number of replicas to 0 when there is no incoming traffic. This feature is based on request patterns rather than accelerator utilization. When an endpoint remains idle without receiving any requests for over 15 minutes, the system automatically scales down the endpoint to 0 replicas. To enable the feature, go to the Settings page and you\u2019ll find a section called \u201CAutomatic Scale-to-Zero\u201D."),xt.forEach(t),ge=p(e),$=o(e,"P",{});var Ae=n($);at=c(Ae,"Scaling to 0 replicas helps optimize cost savings by minimizing resource usage during periods of inactivity. However, it\u2019s important to be aware that scaling to 0 implies a cold start period when the endpoint receives a new request. Additionally, the HTTP server will respond with a status code "),ie=o(Ae,"CODE",{});var Lt=n(ie);ot=c(Lt,"502 Bad Gateway"),Lt.forEach(t),nt=c(Ae," while the new replica is initializing. Please note that there is currently no queueing system in place for incoming requests. Therefore, we recommend developing your own request queue client-side with proper error handling to optimize throughput and latency."),Ae.forEach(t),me=p(e),O=o(e,"P",{});var Ht=n(O);rt=c(Ht,"The duration of the cold start period varies depending on your model\u2019s size. It is recommended to consider the potential latency impact when enabling scaling to 0 and managing user expectations."),Ht.forEach(t),this.h()},h(){h(f,"name","hf:doc:metadata"),h(f,"content",JSON.stringify(Zt)),h(w,"id","autoscaling"),h(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(w,"href","#autoscaling"),h(d,"class","relative group"),h(y,"id","scaling-criteria"),h(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(y,"href","#scaling-criteria"),h(g,"class","relative group"),h(b,"id","considerations-for-effective-autoscaling"),h(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(b,"href","#considerations-for-effective-autoscaling"),h(m,"class","relative group"),h(k,"href","https://huggingface.co/inference-endpoints/enterprise"),h(k,"rel","nofollow"),h(A,"id","scaling-to-0"),h(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(A,"href","#scaling-to-0"),h(v,"class","relative group")},m(e,r){i(document.head,f),s(e,oe,r),s(e,d,r),i(d,w),i(w,B),Te(z,B,null),i(d,Ce),i(d,M),i(M,Ge),s(e,ne,r),s(e,I,r),i(I,Ne),s(e,re,r),s(e,g,r),i(g,y),i(y,R),Te(T,R,null),i(g,Ue),i(g,W),i(W,xe),s(e,se,r),s(e,C,r),i(C,Le),s(e,le,r),s(e,_,r),i(_,D),i(D,G),i(G,j),i(j,He),i(G,Oe),i(_,Be),i(_,Z),i(Z,N),i(N,J),i(J,Me),i(N,Re),s(e,ce,r),s(e,U,r),i(U,We),s(e,he,r),s(e,m,r),i(m,b),i(b,F),Te(S,F,null),i(m,De),i(m,K),i(K,je),s(e,ue,r),s(e,x,r),i(x,Ze),s(e,pe,r),s(e,E,r),i(E,Q),i(Q,L),i(L,V),i(V,Je),i(L,Fe),i(E,Ke),i(E,X),i(X,P),i(P,Y),i(Y,Qe),i(P,Ve),i(P,k),i(k,Xe),i(P,Ye),s(e,fe,r),s(e,v,r),i(v,A),i(A,ee),Te(q,ee,null),i(v,et),i(v,te),i(te,tt),s(e,de,r),s(e,H,r),i(H,it),s(e,ge,r),s(e,$,r),i($,at),i($,ie),i(ie,ot),i($,nt),s(e,me,r),s(e,O,r),i(O,rt),ve=!0},p:Wt,i(e){ve||(Se(z.$$.fragment,e),Se(T.$$.fragment,e),Se(S.$$.fragment,e),Se(q.$$.fragment,e),ve=!0)},o(e){ke(z.$$.fragment,e),ke(T.$$.fragment,e),ke(S.$$.fragment,e),ke(q.$$.fragment,e),ve=!1},d(e){t(f),e&&t(oe),e&&t(d),qe(z),e&&t(ne),e&&t(I),e&&t(re),e&&t(g),qe(T),e&&t(se),e&&t(C),e&&t(le),e&&t(_),e&&t(ce),e&&t(U),e&&t(he),e&&t(m),qe(S),e&&t(ue),e&&t(x),e&&t(pe),e&&t(E),e&&t(fe),e&&t(v),qe(q),e&&t(de),e&&t(H),e&&t(ge),e&&t($),e&&t(me),e&&t(O)}}}const Zt={local:"autoscaling",sections:[{local:"scaling-criteria",title:"Scaling Criteria"},{local:"considerations-for-effective-autoscaling",title:"Considerations for Effective Autoscaling"},{local:"scaling-to-0",title:"Scaling to 0"}],title:"Autoscaling"};function Jt(ht){return Dt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Qt extends Ot{constructor(f){super();Bt(this,f,Jt,jt,Mt,{})}}export{Qt as default,Zt as metadata};
